"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _context = _interopRequireDefault(require("./context"));
var _Picker = _interopRequireDefault(require("./components/Picker"));
var _constants = require("./constants");
var _useColorPicker = require("./hooks/useColorPicker");
Object.keys(_useColorPicker).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _useColorPicker[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _useColorPicker[key];
    }
  });
});
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ColorPicker(_ref) {
  var _ref$value = _ref.value,
    value = _ref$value === void 0 ? 'rgba(175, 51, 242, 1)' : _ref$value,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
    _ref$hideControls = _ref.hideControls,
    hideControls = _ref$hideControls === void 0 ? false : _ref$hideControls,
    _ref$hideInputs = _ref.hideInputs,
    hideInputs = _ref$hideInputs === void 0 ? false : _ref$hideInputs,
    _ref$hideOpacity = _ref.hideOpacity,
    hideOpacity = _ref$hideOpacity === void 0 ? false : _ref$hideOpacity,
    _ref$hidePresets = _ref.hidePresets,
    hidePresets = _ref$hidePresets === void 0 ? false : _ref$hidePresets,
    _ref$hideHue = _ref.hideHue,
    hideHue = _ref$hideHue === void 0 ? false : _ref$hideHue,
    _ref$presets = _ref.presets,
    presets = _ref$presets === void 0 ? [] : _ref$presets,
    _ref$hideEyeDrop = _ref.hideEyeDrop,
    hideEyeDrop = _ref$hideEyeDrop === void 0 ? false : _ref$hideEyeDrop,
    _ref$hideAdvancedSlid = _ref.hideAdvancedSliders,
    hideAdvancedSliders = _ref$hideAdvancedSlid === void 0 ? false : _ref$hideAdvancedSlid,
    _ref$hideColorGuide = _ref.hideColorGuide,
    hideColorGuide = _ref$hideColorGuide === void 0 ? false : _ref$hideColorGuide,
    _ref$hideInputType = _ref.hideInputType,
    hideInputType = _ref$hideInputType === void 0 ? false : _ref$hideInputType,
    _ref$hideColorTypeBtn = _ref.hideColorTypeBtns,
    hideColorTypeBtns = _ref$hideColorTypeBtn === void 0 ? false : _ref$hideColorTypeBtn,
    _ref$hideGradientType = _ref.hideGradientType,
    hideGradientType = _ref$hideGradientType === void 0 ? false : _ref$hideGradientType,
    _ref$hideGradientAngl = _ref.hideGradientAngle,
    hideGradientAngle = _ref$hideGradientAngl === void 0 ? false : _ref$hideGradientAngl,
    _ref$hideGradientStop = _ref.hideGradientStop,
    hideGradientStop = _ref$hideGradientStop === void 0 ? false : _ref$hideGradientStop,
    _ref$hideGradientCont = _ref.hideGradientControls,
    hideGradientControls = _ref$hideGradientCont === void 0 ? false : _ref$hideGradientCont,
    _ref$locales = _ref.locales,
    locales = _ref$locales === void 0 ? _constants.defaultLocales : _ref$locales,
    _ref$width = _ref.width,
    width = _ref$width === void 0 ? 294 : _ref$width,
    _ref$height = _ref.height,
    height = _ref$height === void 0 ? 294 : _ref$height,
    _ref$style = _ref.style,
    style = _ref$style === void 0 ? {} : _ref$style,
    className = _ref.className;
  var contRef = (0, _react.useRef)(null);
  var _useState = (0, _react.useState)({}),
    _useState2 = _slicedToArray(_useState, 2),
    bounds = _useState2[0],
    setBounds = _useState2[1];
  (0, _react.useEffect)(function () {
    var _contRef$current;
    setBounds(contRef === null || contRef === void 0 ? void 0 : (_contRef$current = contRef.current) === null || _contRef$current === void 0 ? void 0 : _contRef$current.getBoundingClientRect());
  }, []);
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: contRef,
    style: _objectSpread(_objectSpread({}, style), {}, {
      width: width
    }),
    className: className
  }, /*#__PURE__*/_react["default"].createElement(_context["default"], {
    bounds: bounds,
    value: value,
    onChange: onChange,
    squareSize: width,
    squareHeight: height,
    hideOpacity: hideOpacity
  }, /*#__PURE__*/_react["default"].createElement(_Picker["default"], {
    hideControls: hideControls,
    hideInputs: hideInputs,
    hidePresets: hidePresets,
    hideOpacity: hideOpacity,
    hideHue: hideHue,
    presets: presets,
    hideEyeDrop: hideEyeDrop,
    hideAdvancedSliders: hideAdvancedSliders,
    hideColorGuide: hideColorGuide,
    hideInputType: hideInputType,
    hideColorTypeBtns: hideColorTypeBtns,
    hideGradientType: hideGradientType,
    hideGradientAngle: hideGradientAngle,
    hideGradientStop: hideGradientStop,
    hideGradientControls: hideGradientControls,
    locales: locales
  })));
}
var _default = ColorPicker;
exports["default"] = _default;